diff --git a/gdb/ada-casefold.h b/gdb/ada-casefold.h
index f7c1fca25f9..5c091e808af 100644
--- a/gdb/ada-casefold.h
+++ b/gdb/ada-casefold.h
@@ -1,4 +1,4 @@
-/* *INDENT-OFF* */ /* THIS FILE IS GENERATED -*- buffer-read-only: t -*- */
+/* THIS FILE IS GENERATED -*- buffer-read-only: t -*- */
 /* vi:set ro: */
 
 /* UTF-32 case-folding for GDB
diff --git a/gdb/alpha-mdebug-tdep.c b/gdb/alpha-mdebug-tdep.c
index 7050a7d8a4d..868083b3ace 100644
--- a/gdb/alpha-mdebug-tdep.c
+++ b/gdb/alpha-mdebug-tdep.c
@@ -31,7 +31,6 @@
 
 /* FIXME: Some of this code should perhaps be merged with mips.  */
 
-/* *INDENT-OFF* */
 /* Layout of a stack frame on the alpha:
 
 		|				|
@@ -74,7 +73,6 @@
    -------------|-------------------------------|<-- sp
 		|				|
 */
-/* *INDENT-ON* */
 
 #define PROC_LOW_ADDR(proc) ((proc)->pdr.adr)
 #define PROC_FRAME_OFFSET(proc) ((proc)->pdr.frameoffset)
diff --git a/gdb/arm-tdep.c b/gdb/arm-tdep.c
index 347f3e6b307..5c58efaf423 100644
--- a/gdb/arm-tdep.c
+++ b/gdb/arm-tdep.c
@@ -1846,7 +1846,6 @@ arm_skip_prologue (struct gdbarch *gdbarch, CORE_ADDR pc)
 				 target_arm_instruction_reader ());
 }
 
-/* *INDENT-OFF* */
 /* Function: thumb_scan_prologue (helper function for arm_scan_prologue)
    This function decodes a Thumb function prologue to determine:
      1) the size of the stack frame
@@ -1866,7 +1865,6 @@ arm_skip_prologue (struct gdbarch *gdbarch, CORE_ADDR pc)
    
    The comments for thumb_skip_prolog() describe the algorithm we use
    to detect the end of the prolog.  */
-/* *INDENT-ON* */
 
 static void
 thumb_scan_prologue (struct gdbarch *gdbarch, CORE_ADDR prev_pc,
diff --git a/gdb/defs.h b/gdb/defs.h
index b6a132173fb..44eeab4dffd 100644
--- a/gdb/defs.h
+++ b/gdb/defs.h
@@ -1,5 +1,3 @@
-/* *INDENT-OFF* */ /* ATTRIBUTE_PRINTF confuses indent, avoid running it
-		      for now.  */
 /* Basic, host-specific, and target-specific definitions for GDB.
    Copyright (C) 1986-2023 Free Software Foundation, Inc.
 
diff --git a/gdb/gdbarch-gen.h b/gdb/gdbarch-gen.h
index 32b2d96fbe0..ddb97f60315 100644
--- a/gdb/gdbarch-gen.h
+++ b/gdb/gdbarch-gen.h
@@ -1,4 +1,4 @@
-/* *INDENT-OFF* */ /* THIS FILE IS GENERATED -*- buffer-read-only: t -*- */
+/* THIS FILE IS GENERATED -*- buffer-read-only: t -*- */
 /* vi:set ro: */
 
 /* Dynamic architecture support for GDB, the GNU debugger.
diff --git a/gdb/gdbarch.c b/gdb/gdbarch.c
index 04fcc92f8f9..7e4e34d5aca 100644
--- a/gdb/gdbarch.c
+++ b/gdb/gdbarch.c
@@ -1,4 +1,4 @@
-/* *INDENT-OFF* */ /* THIS FILE IS GENERATED -*- buffer-read-only: t -*- */
+/* THIS FILE IS GENERATED -*- buffer-read-only: t -*- */
 /* vi:set ro: */
 
 /* Dynamic architecture support for GDB, the GNU debugger.
diff --git a/gdb/gdbcopyright.py b/gdb/gdbcopyright.py
index 9a52bc1d847..e87ce0d4ad2 100644
--- a/gdb/gdbcopyright.py
+++ b/gdb/gdbcopyright.py
@@ -25,7 +25,7 @@ def copyright(tool, description):
             if line.startswith("# Copyright (C) "):
                 dateline = line[1:].strip()
                 break
-    return f"""/* *INDENT-OFF* */ /* THIS FILE IS GENERATED -*- buffer-read-only: t -*- */
+    return f"""/* THIS FILE IS GENERATED -*- buffer-read-only: t -*- */
 /* vi:set ro: */
 
 /* {description}
diff --git a/gdb/go32-nat.c b/gdb/go32-nat.c
index 566d6d58f1c..445f26f73dc 100644
--- a/gdb/go32-nat.c
+++ b/gdb/go32-nat.c
@@ -154,7 +154,6 @@ static void load_npx (void);	/* Restore the FPU of the debugged program.  */
 
 /* ------------------------------------------------------------------------- */
 /* Store the contents of the NPX in the global variable `npx'.  */
-/* *INDENT-OFF* */
 
 static void
 save_npx (void)
@@ -175,7 +174,6 @@ save_npx (void)
 :     "%eax");
 }
 
-/* *INDENT-ON* */
 
 
 /* ------------------------------------------------------------------------- */
diff --git a/gdb/mips-linux-tdep.c b/gdb/mips-linux-tdep.c
index 327678760e3..9f5d5b32408 100644
--- a/gdb/mips-linux-tdep.c
+++ b/gdb/mips-linux-tdep.c
@@ -852,7 +852,6 @@ static const struct tramp_frame micromips_linux_n64_rt_sigframe = {
   micromips_linux_sigframe_validate
 };
 
-/* *INDENT-OFF* */
 /* The unwinder for o32 signal frames.  The legacy structures look
    like this:
 
@@ -927,7 +926,6 @@ static const struct tramp_frame micromips_linux_n64_rt_sigframe = {
      struct sigcontext uc_mcontext;
      sigset_t          uc_sigmask;
    };  */
-/* *INDENT-ON* */
 
 #define SIGFRAME_SIGCONTEXT_OFFSET   (6 * 4)
 
@@ -1066,7 +1064,6 @@ mips_linux_o32_sigframe_init (const struct tramp_frame *self,
   trad_frame_set_id (this_cache, frame_id_build (frame_sp, func));
 }
 
-/* *INDENT-OFF* */
 /* For N32/N64 things look different.  There is no non-rt signal frame.
 
   struct rt_sigframe_n32 {
@@ -1122,7 +1119,6 @@ mips_linux_o32_sigframe_init (const struct tramp_frame *self,
   That is the post-2.6.12 definition of the 64-bit sigcontext; before
   then, there were no hi1-hi3 or lo1-lo3.  Cause and badvaddr were
   included too.  */
-/* *INDENT-ON* */
 
 #define N32_STACK_T_SIZE		STACK_T_SIZE
 #define N64_STACK_T_SIZE		(2 * 8 + 4)
diff --git a/gdb/ppc-linux-nat.c b/gdb/ppc-linux-nat.c
index d8a8fbdf706..a05d9001bd5 100644
--- a/gdb/ppc-linux-nat.c
+++ b/gdb/ppc-linux-nat.c
@@ -178,7 +178,6 @@ struct ppc_hw_breakpoint
 
    The layout is like this (where x is the actual value of the vscr reg): */
 
-/* *INDENT-OFF* */
 /*
 Big-Endian:
    |.|.|.|.|.....|.|.|.|.||.|.|.|x||.|
@@ -189,7 +188,6 @@ Little-Endian:
    <------->     <-------><-------><->
      VR0           VR31     VSCR    VRSAVE
 */
-/* *INDENT-ON* */
 
 typedef char gdb_vrregset_t[PPC_LINUX_SIZEOF_VRREGSET];
 
@@ -628,7 +626,6 @@ struct ppc_linux_nat_target final : public linux_nat_target
 
 static ppc_linux_nat_target the_ppc_linux_nat_target;
 
-/* *INDENT-OFF* */
 /* registers layout, as presented by the ptrace interface:
 PT_R0, PT_R1, PT_R2, PT_R3, PT_R4, PT_R5, PT_R6, PT_R7,
 PT_R8, PT_R9, PT_R10, PT_R11, PT_R12, PT_R13, PT_R14, PT_R15,
@@ -643,7 +640,6 @@ PT_FPR0 + 40, PT_FPR0 + 42, PT_FPR0 + 44, PT_FPR0 + 46,
 PT_FPR0 + 48, PT_FPR0 + 50, PT_FPR0 + 52, PT_FPR0 + 54,
 PT_FPR0 + 56, PT_FPR0 + 58, PT_FPR0 + 60, PT_FPR0 + 62,
 PT_NIP, PT_MSR, PT_CCR, PT_LNK, PT_CTR, PT_XER, PT_MQ */
-/* *INDENT_ON * */
 
 static int
 ppc_register_u_addr (struct gdbarch *gdbarch, int regno)
diff --git a/gdb/rs6000-tdep.c b/gdb/rs6000-tdep.c
index 592b447948e..104515de030 100644
--- a/gdb/rs6000-tdep.c
+++ b/gdb/rs6000-tdep.c
@@ -1633,7 +1633,6 @@ skip_prologue (struct gdbarch *gdbarch, CORE_ADDR pc, CORE_ADDR lim_pc,
 	     address at runtime, can appear to save more than one link
 	     register vis:
 
-	     *INDENT-OFF*
 	     stwu r1,-304(r1)
 	     mflr r3
 	     bl 0xff570d0 (blrl)
@@ -1642,7 +1641,6 @@ skip_prologue (struct gdbarch *gdbarch, CORE_ADDR pc, CORE_ADDR lim_pc,
 	     stw r31,300(r1)
 	     stw r3,308(r1);
 	     ...
-	     *INDENT-ON*
 
 	     remember just the first one, but skip over additional
 	     ones.  */
diff --git a/gdb/stabsread.c b/gdb/stabsread.c
index ca9132b37d0..e1597907778 100644
--- a/gdb/stabsread.c
+++ b/gdb/stabsread.c
@@ -2992,7 +2992,6 @@ read_struct_fields (struct stab_field_info *fip, const char **pp,
     }
   return 1;
 }
-/* *INDENT-OFF* */
 /* The stabs for C++ derived classes contain baseclass information which
    is marked by a '!' character after the total size.  This function is
    called when we encounter the baseclass marker, and slurps up all the
@@ -3016,7 +3015,6 @@ read_struct_fields (struct stab_field_info *fip, const char **pp,
 	Type number of base class ____________________________________|
 
   Return 1 for success, 0 for (error-type-inducing) failure.  */
-/* *INDENT-ON* */
 
 
 
diff --git a/gdb/target-delegates.c b/gdb/target-delegates.c
index ebbc5c8c13d..57b66ce87b1 100644
--- a/gdb/target-delegates.c
+++ b/gdb/target-delegates.c
@@ -1,4 +1,4 @@
-/* *INDENT-OFF* */ /* THIS FILE IS GENERATED -*- buffer-read-only: t -*- */
+/* THIS FILE IS GENERATED -*- buffer-read-only: t -*- */
 /* vi:set ro: */
 
 /* Boilerplate target methods for GDB
diff --git a/gdb/utils.h b/gdb/utils.h
index 7865812998e..6e240deccbf 100644
--- a/gdb/utils.h
+++ b/gdb/utils.h
@@ -1,5 +1,3 @@
-/* *INDENT-OFF* */ /* ATTRIBUTE_PRINTF confuses indent, avoid running it
-		      for now.  */
 /* I/O, string, cleanup, and other random utilities for GDB.
    Copyright (C) 1986-2023 Free Software Foundation, Inc.
 
diff --git a/gdb/xcoffread.c b/gdb/xcoffread.c
index bd6f6521c4c..b74b235ee87 100644
--- a/gdb/xcoffread.c
+++ b/gdb/xcoffread.c
@@ -354,7 +354,7 @@ add_stab_to_list (char *stabname, struct pending_stabs **stabvector)
 }
 
 #endif
-/* *INDENT-OFF* */
+
 /* Linenos are processed on a file-by-file basis.
 
    Two reasons:
@@ -406,7 +406,6 @@ add_stab_to_list (char *stabname, struct pending_stabs **stabvector)
    on when we come the end of the compilation unit.
    Include table (inclTable) and process_linenos() handle
    that.  */
-/* *INDENT-ON* */
 
 
 /* Given a line table with function entries are marked, arrange its